STRICT = true
DEBUG = true

require 'zoetrope'

--require 'group'

require 'version'
--require 'wrap_tile'
require 'player'

GameView = View:extend {
   gameStart = 0,
   onNew = function (self)
              self:loadLayers('data/map.lua')
              self.focus = the.player
              self:clampTo(self.map)

              --the.interface = Group:new()

              --self:add(the.interface)

              self.gameStart = love.timer.getTime()
              self.lastChange = love.timer.getTime()
           end,
   onUpdate = function(self, dt)
                 if the.player.active and love.timer.getTime() > self.lastChange + 10 then
                    -- switch maze

                    self.lastChange = love.timer.getTime()
                 end

                 -- for _, mirror in ipairs(the.mirrors.sprites) do
                 --    if not mirror.of then
                 --       print('mirror:' .. inspect(mirror))
                 --       error('mirror OF NOTHING')
                 --    end
                 -- end
              end,
   onEndFrame = function(self)
                   --the.interface.translate.x = the.player.x - the.app.width / 2 + the.player.width / 2
                   --the.interface.translate.y = the.player.y - the.app.height / 2 + the.player.height / 2
                end
}

MenuScreen = View:extend {
   title = Text:new{text = "Press a key to start", font = 48, wordWrap = false},
   --title = Tile:new{image = 'data/title.png', x = 0, y = 0},
   onNew = function(self)
              self:add(self.title)
              self.title:centerAround(400, 200)
           end,
   onUpdate = function(self, elapsed)
                 if the.keys:allJustPressed() then
                    the.app.view = GameView:new()
                 end
              end
}

the.app = App:new {
   onRun = function (self)
              print('Version: ' .. VERSION)

              self.view = GameView:new()

              if DEBUG then
                 self.console:watch('VERSION', 'VERSION')

                 -- back off that dark overlay a bit
                 self.console.fill.fill[4] = 75
              end
           end,
   onUpdate = function (self, dt)
                 if the.keys:justPressed('escape') then
                    self.quit()
                 end
              end
}
